## mingw-w64-simdjson-3.9.3-1.src.tar.zst

=== tests/ondemand/CMakeLists.txt ===
# All remaining tests link with simdjson proper
link_libraries(simdjson)
include_directories(..)
add_subdirectory(compilation_failure_tests)
add_cpp_test(ondemand_log_tests              LABELS ondemand acceptance per_implementation)
add_cpp_test(ondemand_log_error_tests        LABELS ondemand acceptance per_implementation)
add_cpp_test(ondemand_tostring_tests         LABELS ondemand acceptance per_implementation)
add_cpp_test(ondemand_active_tests           LABELS ondemand acceptance per_implementation)
add_cpp_test(ondemand_array_tests            LABELS ondemand acceptance per_implementation)
add_cpp_test(ondemand_array_error_tests      LABELS ondemand acceptance per_implementation)
add_cpp_test(ondemand_compilation_tests      LABELS ondemand acceptance per_implementation)
add_cpp_test(ondemand_document_stream_tests  LABELS ondemand acceptance per_implementation)
add_cpp_test(ondemand_error_tests            LABELS ondemand acceptance per_implementation)
add_cpp_test(ondemand_error_location_tests   LABELS ondemand acceptance per_implementation)
add_cpp_test(ondemand_json_pointer_tests     LABELS ondemand acceptance per_implementation)
add_cpp_test(ondemand_json_path_tests        LABELS ondemand acceptance per_implementation)
add_cpp_test(ondemand_key_string_tests       LABELS ondemand acceptance per_implementation)
add_cpp_test(ondemand_misc_tests             LABELS ondemand acceptance per_implementation)
add_cpp_test(ondemand_number_tests           LABELS ondemand acceptance per_implementation)
add_cpp_test(ondemand_number_in_string_tests LABELS ondemand acceptance per_implementation)
add_cpp_test(ondemand_object_tests           LABELS ondemand acceptance per_implementation)
add_cpp_test(ondemand_object_error_tests     LABELS ondemand acceptance per_implementation)
add_cpp_test(ondemand_ordering_tests         LABELS ondemand acceptance per_implementation)
add_cpp_test(ondemand_parse_api_tests        LABELS ondemand acceptance per_implementation)
add_cpp_test(ondemand_readme_examples        LABELS ondemand acceptance per_implementation)
add_cpp_test(ondemand_scalar_tests           LABELS ondemand acceptance per_implementation)
add_cpp_test(ondemand_to_string              LABELS ondemand acceptance per_implementation)
add_cpp_test(ondemand_twitter_tests          LABELS ondemand acceptance per_implementation)
add_cpp_test(ondemand_wrong_type_error_tests LABELS ondemand acceptance per_implementation)
add_cpp_test(ondemand_iterate_many_csv       LABELS ondemand acceptance per_implementation)

if(HAVE_POSIX_FORK AND HAVE_POSIX_WAIT) # assert tests use fork and wait, which aren't on MSVC
  add_cpp_test(ondemand_assert_out_of_order_values LABELS assert per_implementation explicitonly ondemand)
endif()

# Copy the simdjson dll into the tests directory
if(MSVC AND BUILD_SHARED_LIBS)
  add_custom_command(TARGET ondemand_parse_api_tests POST_BUILD        # Adds a post-build event
    COMMAND ${CMAKE_COMMAND} -E copy_if_different  # which executes "cmake -E copy_if_different..."
        "$<TARGET_FILE:simdjson>"      # <--this is in-file
        "$<TARGET_FILE_DIR:ondemand_parse_api_tests>")                 # <--this is out-file path
endif(MSVC AND BUILD_SHARED_LIBS)

=== PKGBUILD ===
# Maintainer: Alexey Pavlov <alexpux@gmail.com>

_realname=simdjson
pkgbase=mingw-w64-${_realname}
pkgname="${MINGW_PACKAGE_PREFIX}-${_realname}"
pkgver=3.9.3
pkgrel=1
pkgdesc="A C++ library to see how fast we can parse JSON with complete validation (mingw-w64)"
arch=('any')
mingw_arch=('mingw32' 'mingw64' 'ucrt64' 'clang64' 'clangarm64' 'clang32')
msys2_references=(
  'aur: simdjson'
)
msys2_repository_url='https://github.com/simdjson/simdjson/'
url='https://simdjson.org/'
license=('spdx:Apache-2.0')
depends=("${MINGW_PACKAGE_PREFIX}-gcc-libs")
makedepends=("${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-cc")
source=("${_realname}-${pkgver}.tar.gz::https://github.com/simdjson/simdjson/archive/v${pkgver}.tar.gz")
sha512sums=('893ce0cb380b1418438f5910262325031f8071c4577589a491713f91c980964b4105c1e1aa7f2b9373deed40ecf6b48fe48a1aa243151e424f138f5418e4821c')

build() {
  mkdir -p "${srcdir}/build-dynamic-${MSYSTEM}" && cd "${srcdir}/build-dynamic-${MSYSTEM}"

  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake.exe \
    -G "Ninja" \
    -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
    "${_extra_config[@]}" \
    -DBUILD_SHARED_LIBS=ON \
    "../${_realname}-${pkgver}"

  ${MINGW_PREFIX}/bin/cmake.exe --build ./
  
  mkdir -p "${srcdir}/build-static-${MSYSTEM}" && cd "${srcdir}/build-static-${MSYSTEM}"
  
  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake.exe \
    -G "Ninja" \
    -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
    "${_extra_config[@]}" \
    -DBUILD_SHARED_LIBS=OFF \
    "../${_realname}-${pkgver}"

  ${MINGW_PREFIX}/bin/cmake.exe --build ./
}

check() {
  cd "${srcdir}/build-dynamic-${MSYSTEM}"
  ${MINGW_PREFIX}/bin/ctest.exe ./ || true

  cd "${srcdir}/build-static-${MSYSTEM}"
  ${MINGW_PREFIX}/bin/ctest.exe ./ || true
}

package() {
  cd "${srcdir}/build-static-${MSYSTEM}"
  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake.exe --install ./

  cd "${srcdir}/build-dynamic-${MSYSTEM}"
  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake.exe --install ./

  install -Dm644 "${srcdir}/${_realname}-${pkgver}/README.md" "${pkgdir}${MINGW_PREFIX}/share/doc/${_realname}/README.md"
  install -Dm644 "${srcdir}/${_realname}-${pkgver}/LICENSE" "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE"
}
